<?php
/*======================================================================*\
|| #################################################################### ||
|| # ragtek  Extended Forum Management  1.0.0 Beta1
|| # Build: 1
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2011 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/

class Ragtek_DTFN_Model extends XenForo_Model
{

    public function deleteForumThreads($forumId)
    {

        $threads = $this->_getThreadsInForum($forumId);

        $dw = $this->_getThreadDM();
        foreach ($threads AS $thread) {
            $dw->setExistingData($thread);
            $dw->delete();
        }
    }


    public function deleteForum($forumId){
        $dw = $this->_getForumDM();
        $dw->setExistingData($forumId);
        $dw->delete();
    }

    protected function _getThreadsInForum($forumId)
    {
        $threadModel = $this->_getForumModel();

        $threads = $threadModel->getThreadsInForum($forumId);
        return $threads;
    }


    /**
     * @return XenForo_DataWriter_Forum
     */
    protected function _getForumDM(){
        return XenForo_DataWriter::create('XenForo_Datawriter_Forum');
    }

    /**
     * @return XenForo_DataWriter_Discussion_Thread
     */
    protected function _getThreadDM()
    {
        return XenForo_DataWriter::create('XenForo_DataWriter_Discussion_Thread');
    }

    /**
     * @return XenForo_Model_Thread
     */
    protected function _getForumModel()
    {
        return $this->getModelFromCache('XenForo_Model_Thread');
    }
}
 
