<?php

class Ragtek_DTFN_ControllerAdmin_Index extends XenForo_ControllerAdmin_Abstract
{
    public function actionIndex()
    {


        /** @var $nodes XenForo_Model_Node */
        $nodes = $this->getModelFromCache('XenForo_Model_Node');

        $params = array(
            'nodes' => $nodes->getAllNodes()
        );

        return $this->responseView('', 'ragtek_dtfn_index', $params);
    }

    public function actionDelete()
    {
        if ($this->isConfirmedPost() AND $id = $this->_input->filterSingle('node', XenForo_Input::UINT)) {
            $model = $this->_getModel();
            $model->deleteForumThreads($id);

            if ($this->_input->filterSingle('deleteForum', XenForo_Input::UINT)) {
                $model->deleteForum($id);
            }
        }

        return $this->responseRedirect(
			XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED,
			XenForo_Link::buildAdminLink('ragtek_deletenode')
		);
    }

    /**
     * @return Ragtek_DTFN_Model
     */
    protected function _getModel()
    {
        return $this->getModelFromCache('Ragtek_DTFN_Model');
    }
}