<?php

class Ragtek_DTFN_Install{


    public function _installVersion1(){

        $db = XenForo_Application::get('db');
        Ragtek_DTFN_InstallCheck::install();
    }



    /**
     *
     * @param array     Current version of the installed add-on (if installed)
     * @param array     Version of the add-on which will be released
     *
     */
    	public static function install($existingAddOn, $addOnData)
	{
		$startVersionId = 1;
		$endVersionId = $addOnData['version_id'];

		if ($existingAddOn)
		{
			$startVersionId = $existingAddOn['version_id'] + 1;
		}
		$install = self::getInstance();

		for ($i = $startVersionId; $i <= $endVersionId; $i++)
		{
			$method = '_installVersion' . $i;
			if (method_exists($install, $method) === false)
			{
				continue;
			}
			$install->$method();
		}
	}

	public static function _runQuery(array $queries)
    {
        $db = XenForo_Application::get('db');
        foreach ($queries AS $id => $query) {
            $db->query($query);
        }
    }


        static private $instance = null;

        public static function getInstance() {

                    if (self::$instance == null){
                    self::$instance = new self();
                    }
        return self::$instance;
    }
}